// FILENAME:	DM_SanAntonio_Challenge.cs				  
//
// AUTHORS:  	{VTTK}Zoltar~/-|-|~
//
// READER'S NOTE: Just a fun map thats all :)
//                
//
//------------------------------------------------------------------------------

$missionName = "DM_SanAntonio_Challenge";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

// what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;

// what can the server admin choose for available teams
        $server::disableTeamRed = true;
        $server::disableTeamBlue = false;
        $server::disableTeamYellow = true;
        $server::disableTeamPurple = false;
}
function player::onAdd(%this)
{
       
        say (%this, 0, "Welcome to Zoltars Map, DM_SanAntonio_Challenge!");
	say (%this, 1, "Be sure to read the info tab for game rules");
	say (%this, 2, "This map is still indevelopment and CURRENTLY NOT AVAILABLE FOR DOWNLOAD, sorry");
	say (%this, 3, "Also check out Zoltars other maps Chiller, Thunder_Canyon, King_Arthurs_Revenge, Manglers_Conquest and Dual_the_Goad");
	say (%this, 4, "now avail for download at: http//www.starsiegeplayers.com");
}

//--------------------------------------------------------------------------------
function onMissionStart()
{
	cdAudioCycle("Gnash", "Cloudburst", "Cyberntx"); 
	windSounds();	
   
// custom rules for this mission ( teleporter )
   %rules = "<tIDMULT_TDM_GAMETYPE>"   @        
            "<tIDMULT_TDM_MAPNAME>"    @ 
            $missionName               @
            "<tIDMULT_TDM_OBJECTIVES>" @
            "<tIDMULT_TDM_SCORING_1>"  @
            "<tIDMULT_TDM_SCORING_2>"  @
            $killPoints                @
            "<tIDMULT_TDM_SCORING_3>"  @
            "<tIDMULT_TDM_SCORING_4>"  @
            $deathPoints               @
            "<tIDMULT_TDM_SCORING_5>"  @
            "<tIDMULT_TDM_SCORING_6>"  @
            "<tIDMULT_STD_ITEMS>"      @
            "<tIDMULT_STD_TELEPORTER>" @
            "<tIDMULT_STD_HEAL>"       @
            "<tIDMULT_STD_RELOAD>";
  
   setGameInfo(%rules);  

}
//This function inflicts damage to players who venture too close to Manglers throne

function getMangled::trigger::onEnter(%this, %vehicleId){
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	if(%player == 0)
	return;
	say(%player, 0,"sfx_thunder2.wav");
	say(%player, 0,"Now you'll sample Manglers Wrath for wandering too close to the throne!!");
	
}
//If someone shoots Mangler, his houses blow up revealing a nasty surprise
//------------------------------------------------
function tur1::turret::onAdd(%this)
{
	$turret1=%this;
	order($turret1,ShutDown,true);
}
function tur2::turret::onAdd(%this)
{
	$turret2=%this;
	order($turret2,ShutDown,true);
}
function Mangler::structure::onAttacked(%attacked,%attacker)
{
	%bang1=getObjectId("MissionGroup\\extra\\Mangler'sThrone\\Manglershouse1");
	healObject(%bang1,-30000);
	order($turret1,ShutDown,false);
	order($turret1, Attack, %attacker);
	%bang2=getObjectId("MissionGroup\\extra\\Mangler'sThrone\\Manglershouse2");
	healObject(%bang2,-30000);
	order($turret2,ShutDown,false);
	order($turret2, Attack, %attacker);
}
//----------------------------------------------
//These functions are for teleporters to work

function ZenTransporter1::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, 1215.53, -7249, 1540);
	say(0,1,"sfx_steam.wav");
}
function ZenTransporter2::trigger::onContact(%this, %object)
{
	Zen::work(%this, %object, 100000, 100, 0, false);
	setPosition(%object, 1100.61, -796.884, 796.104);
	say(0,1,"sfx_steam.wav");
}
//------------------------------------------------------------------------------
//This command enables sound effects around the map

function soundEffect1::trigger::onEnter(%this, %vehicleId){
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	if(%player == 0)
	return;
	say(%player, 0, "You've elected to challenge San Antonios defense...", "sfx_thunder2.wav");
}
function soundEffect2::trigger::onEnter(%this, %vehicleId){
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	if(%player == 0)
	return;
	say(%player, 0,"say your prayers!", "scene5.wav");
}
function soundEffect3::trigger::onEnter(%this, %vehicleId){
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	if(%player == 0)
	return;
	say(%player, 0,"Herc Revitalization zone, watch your footing!", "sfx_windgust.wav");
}
function soundEffect4::trigger::onEnter(%this, %vehicleId){
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	if(%player == 0)
	return;
	say(%player, 0,"Executing new directive <R&R for all pilots> heh heh yah right!", "sfx_thunder2.wav");
}