// FILENAME:	SSL_Ida.cs
//
// Based On:      Campaign map, Cmoo04, Earth
//
// AUTHORS:  	Temujin
//------------------------------------------------------------------------------

$missionName = "SSL_Ida";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

$yellowHealRate = $blueHealRate = $redHealRate = $purpleHealRate = 750;
$padWaitTime = 15;
$zenWaitTime = 60;

$radius = 200;
$damage = 10000;

$server::HudMapViewOffsetX = 500;
$server::HudMapViewOffsetY = -275;

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to the Asteroid Ida!\n" @
	$missionName @ " designed by ''|''mJ, and is available at http://temujin.www6.50megs.com\n\n" @
	"This map was designed for SLA StarSiege League Games.\n" @
	"Blue team is defending, red team is on the attack.\n"  ) ;
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Terror", "Watching"); 
}

function fueltank::structure::onDestroyed(%this, %object)
{
   	blast(%this, $radius, $damage, 0);

	%target = getObjectId("MissionGroup\\BlueBase\\BOOM");
	%x = getPosition(%this,x);
	%y = getPosition(%this,y);
	%z = getPosition(%this,z);
	setPosition(%target, %x, %y, %z);
	playAnimSequence(%target, 0, true);
	schedule("LowerBoom("@%target@");", 1 );
}

function LowerBoom(%this)
{
	setposition(%this, 0, 0, 0);
}