//21 - probably ok - test on server

// Timers - onArriveNavBravo-1800, Heybaby-900 - make 360  
//----  script file, Boris&Natasha
//===========================================

// AUTHORS:  	Slade & Filthy Clyde
// Code stolen happily from Dolf Kooz Maps and mike the goad.  Map stolen from Chupie Doll
// & Youth In Asia
// Version 1.08c

console::enable(true);

$OVconvoyTech = 1;

$server::TeamDamage = true;

$actionStarted = false;

$maxRange = 3200;
$minRange = 500;

// how many player are alive at squad drop time
$numLivePlayers = 0;
//------------------------------------------------------------------

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------------------------------------------------------------------
Pilot backupPilot
{
   id = 29;
   
   skill = 0.5;
   accuracy = 0.4;
   aggressiveness = 0.8;
   activateDist = 11000.0;
   deactivateBuff = 12000.0;
   targetFreq = 5.4;
   trackFreq = 2.0;
   fireFreq = 2.0;
   LOSFreq = 0.1;
   orderFreq = 0.2;
};
   

function onMissionLoad()
{

   cdAudioCycle("Purge", "Watching", "Mechsoul"); 


    $textMsg = "Mission Credits:  Slade & Filthy Clyde.  \n\n"@
      "Objectives:  Save the Mountain.  \n"@
                    "Rescue the miners, if possible.  \n"@
                    "Capture or destroy the Cybrid Antigrav Generators.  \n"@
                    "Bring three Generators to the Dropship at Charlie.  \n\n"@ 
                    
   "Respawning is allowed. Destroying an enemy heals your vehicle and"@
   " reloads your weapons. Team Damage is on, watch your fire.";
   %history = 
"\n\nDate: 2832. TAC-COM:  Here is the story people.  Russian miners in Siberia were"@
" getting Lanthanides or Rare Earths from a mountain which is 95% pure.  We need this"@
" stuff to fight the war.  The miners were attacked by Cybrids, we think.  Some of the miners"@
" may be in the mine shafts.  Rescue them.  The miners report that the entire top of the"@
" mountain has been sliced off and stolen.  We think the Brids are using some kind of Giant"@
" Agrav Generators to fly the mountain off in pieces.  Our Scientists need to have a look"@
" at those Generators.  Get three of them to the Dropship, destroy the others, rescue the"@
" miners.  We need to debrief them.  Expect trouble.";

   setGameInfo ($textMsg @ %history);
}


//--------------------------------------------
function onMissionStart()
{
   newFormation( Delta, 0,0,0, -60,-60,0, 60,-45,0, 0,-120,0 ); 
   newFormation( Line,  0,0,0, 0,-40,0, 0,-80,0, 0,-120,0 );

   cdAudioCycle( Purge, Terror, gnash);
   iceSounds();	
   init();

}

//---------------------------------------------

//---------------------------------------------
function player::onAdd(%this)                                                                                                                        
{

say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");

}

//--------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

 messagebox (%player, "Check the game info tab for game details");

                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);


    }


//---------------------------------------------
 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
//        schedule ("healObject(" @ %this @ ", -50000);", 3);

       }
   }

}

//-----------------Use to rotate Navpoints---------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
//   createbackup();
//   createbackup();
//   createbackup();
}
//-------------------------------------------------------------------------
function setNavCharlieON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navCharlie, true, %playerVeh  );
     }
   checkAgravArrive();
   createbackup();
//   createbackup();
//   createbackup();
}
//-------------------------------------------------------------------------

function init()
{

$objective1 = false;
$objective2 = false;
$objective3 = false;
$MN = 0;
$AD = 0;
$Miners1 = "MissionGroup/Miners/Miners1";
$Miners2 = "MissionGroup/Miners/Miners2";
$AA = 0;
$Agrav1 = "MissionGroup/Agravs/Agrav1";
$Agrav2 = "MissionGroup/Agravs/Agrav2";
$Agrav3 = "MissionGroup/Agravs/Agrav3";
$Agrav4 = "MissionGroup/Agravs/Agrav4";
$Agrav5 = "MissionGroup/Agravs/Agrav5";
$Agrav6 = "MissionGroup/Agravs/Agrav6";
$Agrav7 = "MissionGroup/Agravs/Agrav7";
$Agrav8 = "MissionGroup/Agravs/Agrav8";

   $attackStarted = false;



$buildingsDestroyed = 0;
$navAlpha = "MissionGroup/navPoints/navAlpha";
$navBravo = "MissionGroup/navPoints/navBravo";
$navCharlie = "MissionGroup/navPoints/navCharlie";

   MPcheckBoundary( leave, getObjectID ($navAlpha) , 175, onLeaveNavAlphaWarning, 1 );




}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function onLeaveNavAlphaWarning ()
{

   $actionStarted = true;

   schedule( "say(0, 0, \"<f5>You are leaving the drop zone. By doing so you will start the mission.\");", 1 );
   schedule( "say(0, 0, \"<F5>TAC-COM HERE:  Your Dropship Pilots are Boris & Natasha.  If we lose radio communication, they will help you.\");", 15 );
   schedule( "say(0, 0, \"<f5>TAC-COM HERE:  Radio transmission is breaking up.  Dropship Pilots will advise you.\");", 25 );
   schedule( "say(0, 0, \"<f5>Boris:  Observe top of mountain.  Is gone...  Stolen....\");", 35 );
   schedule( "say(0, 0, \"<f5>Natasha:  Boris, don't you want tell them what to do??\");", 45 );
   schedule( "say(0, 0, \"<f5>Boris:  Natasha you right.  You boys go find miners.  At Bravo maybe....\");", 55 );
   schedule( "say(0, 0, \"<f5>Boris:  They hiding in mines....  Just kick snow out of way and go in....\");", 65 );

   $attackStarted = true;
   createbackup();
//   createbackup();
//   createbackup();
   setNavBravoON();
   MPcheckBoundary( enter, getObjectID ($navBravo) , 100, onArriveNavBravo, 2 );
   MPcheckBoundary( enter, getObjectID ($Miners1) , 50, checkMiners1, 2 );
   MPcheckBoundary( enter, getObjectID ($Miners2) , 50, checkMiners2, 2 );
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function onArriveNavBravo()
{

   createDropShip();//at navCharlie
   setNavCharlieON();
   MPcheckBoundary( enter, getObjectID ($navCharlie) , 70, onArriveNavCharlie, 2 );
   schedule( "winCondition();", 3600 ); 
}


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------


function onArriveNavCharlie()
{

 %obj1 = getObjectID ( $navCharlie );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavCharlie();", 10 );
    }

}

//-----------------------HEYBABY LOGIC-----------------------------------------
//-----------------(as in Heybaby, I'm home)-----------------------------------
//-----------------------------------------------------------------------------
function checkAgravArrive()

{
/////
  %var1 = getDistance( $Agrav1, $navCharlie );

  if ( %var1 < 500 )
   {
    if ( %var1 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var1 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav1, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var2 = getDistance( $Agrav2, $navCharlie );

  if ( %var2 < 500 )
   {
    if ( %var2 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var2 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav2, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var3 = getDistance( $Agrav3, $navCharlie );

  if ( %var3 < 500 )
   {
    if ( %var3 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var3 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav3, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var4 = getDistance( $Agrav4, $navCharlie );

  if ( %var4 < 500 )
   {
    if ( %var4 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var4 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav4, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var5 = getDistance( $Agrav5, $navCharlie );

  if ( %var5 < 500 )
   {
    if ( %var5 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var5 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav5, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var6 = getDistance( $Agrav6, $navCharlie );

  if ( %var6 < 500 )
   {
    if ( %var6 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var6 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav6, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var7 = getDistance( $Agrav7, $navCharlie );

  if ( %var7 < 500 )
   {
    if ( %var7 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var7 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav7, -206.00, -5447.00, -500.00 );
   }
/////
/////
  %var8 = getDistance( $Agrav8, $navCharlie );

  if ( %var8 < 500 )
   {
    if ( %var8 > 50 )
     {
      say (0,0, "<f5>Place Agrav Unit under Dropship.");
     }
   }

  if ( %var8 < 50 )
   {
     $AA++;
     Heybaby();
     createbackup();
//     createbackup();
//     createbackup();
     setPosition ($Agrav8, -206.00, -5447.00, -500.00 );
   }
/////
      schedule ("checkAgravArrive();", 30 );

}
//-----------------------------------------------------------------------------

function Heybaby()
{

  if ( $AA == 1 )
   {
   schedule( "say(0, 0, \"<f5>Natasha:  Oh boy Boris.  They brought us present...\");", 1 );     
   schedule( "say(0, 0, \"<f5>Boris:  Is Cybrid Agrav Generator...  Oh, goody gumdrops...\");", 2 );
   schedule( "say(0, 0, \"<f5>Natasha:  Yes Boris, but we need two more.....\");", 3 );     
   }

  if ( $AA == 2 )
   {
   schedule( "say(0, 0, \"<f5>Natasha:  Oh Boris...  They bring us another present...\");", 4 );     
   schedule( "say(0, 0, \"<f5>Boris:  So what??  They still one short.....\");", 5 );
   schedule( "say(0, 0, \"<f5>Natasha:  True Boris, we need one more.....\");", 6 );  
   }

  if ( $AA == 3 )
   {
   schedule( "say(0, 0, \"<f5>Natasha:  Boris, big surprise...  Is last Agrav Generator...\");", 7 );     
   schedule( "say(0, 0, \"<f5>Boris:  Those guys is too good to us.....\");", 8 );
   schedule( "say(0, 0, \"<f5>Natasha:  They is my Heroes, Boris......\");", 9 );  
   $objective3 = true;
   schedule( "say(0, 0, \"<f5>Objective 3 complete.\");", 10 );
   schedule( "winCondition();", 360 ); 
   }

  if ( $AA > 3 )
   {
   schedule( "say(0, 0, \"<f5>Natasha:  Boris, they bringing more stuff.....\");", 11 );     
   schedule( "say(0, 0, \"<f5>Boris:  What kind idiots these guys....  We no got room.....\");", 12 );
   }

}
//-----------------------------------------------------------------------------
function checkMiners1()

{
   $MN++;


  if ( $MN == 1 )
   {
   schedule( "say(0, 0, \"<f5>Boris:  Oh goody Natasha, they find miners....\");", 1 );
   schedule( "say(0, 0, \"<f5>Natasha:  Only half of them, Boris\");", 5 );
   schedule( "say(0, 0, \"<f5>Boris:  Load them up and look for other half....\");", 8 );
   }
  if ( $MN == 2 )
   {
   schedule( "say(0, 0, \"<f5>Boris:  Natasha, they find rest of miners....\");", 1 );
   schedule( "say(0, 0, \"<f5>Natasha:  Oh Boris, they are so wonderful......\");", 5 );
   schedule( "say(0, 0, \"<f5>Objective 1 complete\");", 7 );
   schedule( "say(0, 0, \"<f5>Natasha:  So now what they do, Boris??\");", 10 );
   schedule( "say(0, 0, \"<f5>Boris:  So they take miners to Dropship Natasha, what you think??\");", 15 );
   schedule( "say(0, 0, \"<f5>Natasha:  I think maybe they save mountain, Boris....??\");", 20 );
   schedule( "say(0, 0, \"<f5>Boris:  Is good idea, Natasha.  You blow up all Generators.  Make big Kaboom ! ! !\");", 25 );
   schedule( "say(0, 0, \"<f5>Natasha:  Not all of them, Boris....  The engineers need three of them...\");", 30 );
   schedule( "say(0, 0, \"<f5>Boris:  Ya okay, Natasha.  So bring three to Dropship.  Blow up rest.   Make big Kaboom ! ! !\");", 35 );
   $objective1 = true;
   }
}


//-----------------------------------------------------------------------------

function checkMiners2()

{
   $MN++;

  if ( $MN == 1 )
   {
   schedule( "say(0, 0, \"<f5>Boris:  Oh goody Natasha, they find miners....\");", 1 );
   schedule( "say(0, 0, \"<f5>Natasha:  Only half of them, Boris\");", 5 );
   schedule( "say(0, 0, \"<f5>Boris:  Load them up and look for other half....\");", 8 );
   }
  if ( $MN == 2 )
   {
   schedule( "say(0, 0, \"<f5>Boris:  Natasha, they find rest of miners....\");", 1 );
   schedule( "say(0, 0, \"<f5>Natasha:  Oh Boris, they are so wonderful......\");", 5 );
   schedule( "say(0, 0, \"<f5>Objective 1 complete\");", 7 );
   schedule( "say(0, 0, \"<f5>Natasha:  So now what they do, Boris??\");", 10 );
   schedule( "say(0, 0, \"<f5>Boris:  So they take miners to Dropship Natasha, what you think??\");", 15 );
   schedule( "say(0, 0, \"<f5>Natasha:  I think maybe they save mountain, Boris....??\");", 20 );
   schedule( "say(0, 0, \"<f5>Boris:  Is good idea, Natasha.  You blow up all Generators.  Make big Kaboom ! ! !\");", 25 );
   schedule( "say(0, 0, \"<f5>Natasha:  Not all of them, Boris....  The engineers need three of them...\");", 30 );
   schedule( "say(0, 0, \"<f5>Boris:  Ya okay, Natasha.  So bring three to Dropship.  Blow up rest.   Make big Kaboom ! ! !\");", 35 );
   $objective1 = true;
   }

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function structure::onDestroyed(%this, %who)
{

     if (%this == getObjectId($Agrav1))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav2))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav3))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav4))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav5))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav6))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav7))
     {
      $AD++;
      ADCount();
     }   
     if (%this == getObjectId($Agrav8))
     {
      $AD++;
      ADCount();
     }   
}
//-----------------------------------------------------------------------------
function ADCount()
{
  if ( $AD == 1 )
   {
   schedule( "say(0, 0, \"<f5>One Agrav Generator Destroyed, four to go.....\");", 1 );     
   }
  if ( $AD == 2 )
   {
   schedule( "say(0, 0, \"<f5>Two Agrav Generators Destroyed, three to go.....\");", 1 );     
   }
  if ( $AD == 3 )
   {
   schedule( "say(0, 0, \"<f5>Three Agrav Generators Destroyed, two to go.....\");", 1 );     
   }
  if ( $AD == 4 )
   {
   schedule( "say(0, 0, \"<f5>Four Agrav Generators Destroyed, one to go.....\");", 1 );     
   }
  if ( $AD == 5 )
   {
   schedule( "say(0, 0, \"<f5>Five Agrav Generators Destroyed, Objective 2 complete.....\");", 1 );     
   schedule( "say(0, 0, \"<f5>Don't destroy any more.  Take three to the Dropship\");", 3 );  
   $objective2 = true;
   }
  if ( $AD > 5 )
   {
   schedule( "say(0, 0, \"<f5>Uh oh, somebody got trigger happy.......\");", 1 );     
   }
}
//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{




   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }




  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );

// Team kill, take action
     say(0,0,%killerName@" is being kicked for team-killing "@%name@".");
     say(%who, %who, "", "rules_violated.wav");
     %player = playerManager::vehicleIdToPlayerNum ( %who );
     kick ( %player, *IDMULT_CHAT_TEAM_KILL_KICK );

// allow TKed player to return
     say(%this, %this, "A teammate killed you. You may respawn.");
     %this.state = "tked";
    }

}
//-----------------allow DS to heal--------------------------------------------
function vehicle::onAttacked ( %this, %who )
{
//   if (%this == getObjectId( "$hercD" ) )
     if (%this ==  $hercD )
     {
       healobject ( %this, 5000 );
       healobject ( %this, 5000 );
       healobject ( %this, 5000 );
     }
}


//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();
  %nums = 0;

  if ( $objective1 == true )
    {
     %nums++;
    }
  if ( $objective2 == true )
    {
     %nums++;
    }
  if ( $objective3 == true )
    {
     %nums++;
    }


  if ( %nums == 3 )
    {
     %text = "Miners Rescued, 5 Agravs Destroyed, 3 Captured.  Excellent work team.";
    }

  if ( %nums < 3 )
    {
     %text = "Mission Failed.  Hoo Boy, Fearless Leader is gonna be mad now, Natasha..... ";
    }
  
  messageBox(0, "Mission Over, " @ %nums @ " of 3 objectives completed. "@ %text );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($Miners1);
  deleteVariables($Miners2);
  deleteVariables($Agrav1);
  deleteVariables($Agrav2);
  deleteVariables($Agrav3);
  deleteVariables($Agrav4);
  deleteVariables($Agrav5);
  deleteVariables($Agrav6);
  deleteVariables($Agrav7);
  deleteVariables($Agrav8);
  deleteVariables($hercD);
  deleteVariables($tm1);
  deleteVariables($tm2);
  deleteVariables($tm3);
  deleteVariables($tm4);
  deleteVariables($tm5);
  deleteVariables($tm6);
  deleteVariables($tm7);
  deleteVariables($tm8);
  deleteVariables($MN);
  deleteVariables($AA);
  deleteVariables($AD);

  // $MissionCycling::Stage0 = "c_cybridassault";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($navCharlie);
  deleteVariables($objective1);
  deleteVariables($objective2);
  deleteVariables($objective3);
  deleteVariables($Miners1);
  deleteVariables($Miners2);
  deleteVariables($Agrav1);
  deleteVariables($Agrav2);
  deleteVariables($Agrav3);
  deleteVariables($Agrav4);
  deleteVariables($Agrav5);
  deleteVariables($Agrav6);
  deleteVariables($Agrav7);
  deleteVariables($Agrav8);
  deleteVariables($hercD);
  deleteVariables($tm1);
  deleteVariables($tm2);
  deleteVariables($tm3);
  deleteVariables($tm4);
  deleteVariables($tm5);
  deleteVariables($tm6);
  deleteVariables($tm7);
  deleteVariables($tm8);
  deleteVariables($MN);
  deleteVariables($AA);
  deleteVariables($AD);

  // $MissionCycling::Stage0 = "c_cybridassault";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}
//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function createDropShip()
{
  $hercD = NewObject( "Drop Ship", Flyer, 130); // terran drop ship

  newObject( "dropShipGroup", SimGroup );
  addToSet( "MissionGroup", "dropShipGroup" );
  addToSet( "MissionGroup/dropShipGroup", $hercD );

  setTeam(%herc, *IDSTR_TEAM_YELLOW);
  setPilotId ($hercD,28);

  addToSet( $cargogroup, $hercD );

  setPosition ($hercD, 737.00, 6305.00, 175.00 );

// don't let that ship take off!
   order( $hercD, shutdown, True );
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
function vehicle::onMessage (%this, %message, %_1, %_2, %_3, %_4, %_5, %_6, %_7, %_8, %_9)
{

// have the enemy pick a new target
// attacker can run into buildings
  %who1 = playerManager::vehicleIdToPlayerNum (%this);
  if ( %who1 != 0 ) return;

   %target = pickPlayer ();

   order (%this, attack, %target);
}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 40, %rot);

}

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;

//	if (%t == 1) return "C";
//	if (%t == 2) return "H";
	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{

 $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navAlpha), 4, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 6 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 8 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 10 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 12 );
     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 14 );
     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 16 );
     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 18 );
}

function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navAlpha), 1, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{
 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);

  addToSet(  %thisGroup, %herc );

      %x = %x + 50 ;
      %y = %y + 50 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);

//      if ( RandomInt (1,2) == 1 )
//        {
          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );
//        }
//      else
//        {
//          order ( %thisGroup, guard, $retreatPath );
//        }
    }

//    order (%leadherc, makeleader, true);
//    order ( %thisGroup, formation, Delta );

}




//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particular reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

   dropSquad (%xDrop, %yDrop, %howMany, %squadName);

}
//-------------------------TRANSPORTER--------------------
function ZenTransporter1::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, -372, 173, 916);
}
//---------------------------------------------------------------
function ZenTransporter2::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, -439, 154, 920);
}
//---------------------------------------------------------------
function ZenTransporter3::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, 275, 337, 832);
}
//---------------------------------------------------------------
function ZenTransporter4::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, 352, 355, 821);
}
//---------------------------------------------------------------
function ZenTransporter5::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, -222, 407, 1026);
}
//---------------------------------------------------------------
function ZenTransporter6::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, -243, 362, 1026);
}
//---------------------------------------------------------------
function ZenTransporter7::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, -116, 391, 1026);
}
//---------------------------------------------------------------
function ZenTransporter8::trigger::onContact(%this, %object)
{
   healobject ( %object, 5000 );
   reloadObject(%object, 5000 );
	setPosition(%object, -111, 335, 1026);
}
//---------------------------------------------------------------


//---------------TRACTOR BEAM STUFF FROM "MOVE IT"---------------
//------------------Thank you, mike the goad---------------------
///////////////////////////////////////////////////
function Agrav1::structure::onScan(%this,%scanner)	
{
if($tm1 == "")
 {
 $tm1 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt1();
 }
 else
 {
 $tm1 = "";
 }
}

function mt1()
{
%x = (getPosition($tm1,x) - 50);
%y = (getPosition($tm1,y) + 50);
%z = getPosition($tm1,z);
if(%x == %z)					// he died or left
 {
 $tm1 = "";
 pt1();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav1",%x,%y,%z);

 }
if($tm1 != "")
 {
 schedule("mt1();",0.2);
 }
 else
 {
 pt1();
 }
}

function pt1()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav1",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav1",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav1",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav2::structure::onScan(%this,%scanner)	
{
if($tm2 == "")
 {
 $tm2 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt2();
 }
 else
 {
 $tm2 = "";
 }
}

function mt2()
{
%x = (getPosition($tm2,x) - 50);
%y = (getPosition($tm2,y) + 50);
%z = getPosition($tm2,z);
if(%x == %z)					// he died or left
 {
 $tm2 = "";
 pt2();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav2",%x,%y,%z);

 }
if($tm2 != "")
 {
 schedule("mt2();",0.2);
 }
 else
 {
 pt2();
 }
}

function pt2()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav2",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav2",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav2",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav3::structure::onScan(%this,%scanner)	
{
if($tm3 == "")
 {
 $tm3 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt3();
 }
 else
 {
 $tm3 = "";
 }
}

function mt3()
{
%x = (getPosition($tm3,x) - 50);
%y = (getPosition($tm3,y) + 50);
%z = getPosition($tm3,z);
if(%x == %z)					// he died or left
 {
 $tm3 = "";
 pt3();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav3",%x,%y,%z);

 }
if($tm3 != "")
 {
 schedule("mt3();",0.2);
 }
 else
 {
 pt3();
 }
}

function pt3()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav3",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav3",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav3",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav4::structure::onScan(%this,%scanner)	
{
if($tm4 == "")
 {
 $tm4 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt4();
 }
 else
 {
 $tm4 = "";
 }
}

function mt4()
{
%x = (getPosition($tm1,x) - 50);
%y = (getPosition($tm1,y) + 50);
%z = getPosition($tm1,z);
if(%x == %z)					// he died or left
 {
 $tm4 = "";
 pt4();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav4",%x,%y,%z);

 }
if($tm4 != "")
 {
 schedule("mt4();",0.2);
 }
 else
 {
 pt4();
 }
}

function pt4()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav4",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav4",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav4",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav5::structure::onScan(%this,%scanner)	
{
if($tm5 == "")
 {
 $tm5 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt5();
 }
 else
 {
 $tm5 = "";
 }
}

function mt5()
{
%x = (getPosition($tm5,x) - 50);
%y = (getPosition($tm5,y) + 50);
%z = getPosition($tm5,z);
if(%x == %z)					// he died or left
 {
 $tm5 = "";
 pt5();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav5",%x,%y,%z);

 }
if($tm5 != "")
 {
 schedule("mt5();",0.2);
 }
 else
 {
 pt5();
 }
}

function pt5()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav5",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav5",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav5",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav6::structure::onScan(%this,%scanner)	
{
if($tm6 == "")
 {
 $tm6 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt6();
 }
 else
 {
 $tm6 = "";
 }
}

function mt6()
{
%x = (getPosition($tm6,x) - 50);
%y = (getPosition($tm6,y) + 50);
%z = getPosition($tm6,z);
if(%x == %z)					// he died or left
 {
 $tm6 = "";
 pt6();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav6",%x,%y,%z);

 }
if($tm6 != "")
 {
 schedule("mt6();",0.2);
 }
 else
 {
 pt6();
 }
}

function pt6()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav6",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav6",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav6",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav7::structure::onScan(%this,%scanner)	
{
if($tm7 == "")
 {
 $tm7 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt7();
 }
 else
 {
 $tm7 = "";
 }
}

function mt7()
{
%x = (getPosition($tm7,x) - 50);
%y = (getPosition($tm7,y) + 50);
%z = getPosition($tm7,z);
if(%x == %z)					// he died or left
 {
 $tm7 = "";
 pt7();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav7",%x,%y,%z);

 }
if($tm7 != "")
 {
 schedule("mt7();",0.2);
 }
 else
 {
 pt7();
 }
}

function pt7()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav7",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav7",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav7",%x,%y,%z);
}
///////////////////////////////////////////////////
///////////////////////////////////////////////////
function Agrav8::structure::onScan(%this,%scanner)	
{
if($tm8 == "")
 {
 $tm8 = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to turn Tractor Beam off."); 
 mt8();
 }
 else
 {
 $tm8 = "";
 }
}

function mt8()
{
%x = (getPosition($tm8,x) - 50);
%y = (getPosition($tm8,y) + 50);
%z = getPosition($tm8,z);
if(%x == %z)					// he died or left
 {
 $tm8 = "";
 pt8();
 }
 else
 {
   %z = %z + 3.0;
 setPosition("MissionGroup\\Agravs\\Agrav8",%x,%y,%z);

 }
if($tm8 != "")
 {
 schedule("mt8();",0.2);
 }
 else
 {
 pt8();
 }
}

function pt8()
{
%x = getPosition("MissionGroup\\Agravs\\Agrav8",x);
%y = getPosition("MissionGroup\\Agravs\\Agrav8",y);
%z = (getTerrainHeight(%x,%y) + 3.0);
setPosition("MissionGroup\\Agravs\\Agrav8",%x,%y,%z);
}
///////////////////////////////////////////////////

//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------
