//
// AUTHOR:  	Dangerfreak
//------------------------------------------------------------------------------

$missionName = "DF_Nightmare";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("DF_RemoteLib.cs");

newobject(sound01,simvolume,"sm_rajah.vol");
newobject(sound02,simvolume,"sm_hm1.vol");
newobject(sound03,simvolume,"sm_hm2.vol");
newobject(sound04,simvolume,"sm_cy2.vol");
newobject(sound05,simvolume,"sm_Jaguar.vol");
newobject(sound06,simvolume,"sm_Saxon.vol");
newobject(sound07,simvolume,"sm_Hunter.vol");
newobject(sound08,simvolume,"sm_hman.vol");
newobject(sound09,simvolume,"sm_delta6.vol");
newobject(sound10,simvolume,"sm_eoh.vol");
newobject(sound11,simvolume,"sm_pdog.vol");
newobject(sound12,simvolume,"sm_riana.vol");
newobject(sound13,simvolume,"sm_unrelent.vol");

$server::HudMapViewOffsetX = 14900;
$server::HudMapViewOffsetY = 14900;
$irq=0;

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;

	$server::TeamDamage = false;

}

function setDefaultMissionItems()
{
	allowComponent(all,True);

// keine sensoren erlaubt

	allowcomponent(400,false);
	allowcomponent(401,false);
	allowcomponent(408,false);
	allowcomponent(409,false);
	allowcomponent(410,false);
	allowcomponent(411,false);
	allowcomponent(412,false);
	allowcomponent(413,false);
	allowcomponent(414,false);
	allowcomponent(426,false);
	allowcomponent(427,false);
	allowcomponent(428,false);
	allowcomponent(429,false);
	allowcomponent(430,false);
	allowcomponent(431,false);
	allowcomponent(432,false);
	allowcomponent(433,false);
	allowcomponent(434,false);

// nur basic computer erlaubt

	allowcomponent(801,false);
	allowcomponent(802,false);
	allowcomponent(806,false);
	allowcomponent(807,false);

	// dreckswaffen verbieten
	noCheapWeapons();
}

function onMissionStart()
{
	stormSounds();
}

function onMissionLoad()
{
  %ausgabe1 = "Welcome to the 'Nightmare'! This map is for EXPERTS and DANGERSEEKERS only!\n\n"
	     @ "Fight as a team in nearly complete darkness! You only can choose a small "
             @ "computer and you don't have sensors, so lock your target manually - if you see it!!!"
	     @ "\nHEAR the enemies... FEEL them... SMELL them... KILL THEM!!!\n"
	     @ "Note: Using nav points is a good idea...(m=drop nav / n=switch to next nav)\n\n"
             @ $copyright;
   setGameInfo(%ausgabe1);
   %terrain = getObjectId("MissionGroup\\World\\terrain");
   createAmbientSoundSource(%terrain, 0, 15, 30);
   addToAmbientSoundSource(%terrain, "scene1.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene2.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene3.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene4.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene4.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "scene5.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CA.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CB.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CC.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CD.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "CE.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "cin_he2.wav", IDPRF_2D);
   addToAmbientSoundSource(%terrain, "cin_hb3.wav", IDPRF_2D);
}

// ----------------

function player::onAdd(%this)                                                            
{
	antistealth(%this,"in");
	%ausgabe = "Welcome!";
	say(%this,0,%ausgabe);
	messagebox(%this,"IMPORTANT: Check the Game info tab!!!");
}

// ---------------

function vehicle::onAdd(%vehicleId)
{
	say(0,1,getHudName(%vehicleId) @ " entered the battlefield.");
}

// -----------------
