$missionName = "FiRe_Origins.cs";
console::enable(true);
$server::TeamDamage = true;	

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = treu;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	$Cargo = "MissionGroup/ImperialCargoBase/Cargo";
	$CargoPatrol = "MissionGroup/ImperialCargoBase/CargoPatrol";
	$CargoProtect = "MissionGroup/ImperialCargoBase/CargoProtect";
	$CargoPatrolPath = "MissionGroup/ImperialCargoBase/PatrolPath";
	order($CargoPatrol, guard, $CargoPatrolPath);
	order($CargoProtect, shutdown, true);
			
	$MovieHercs = "MissionGroup/ImperialMovies/Hercs";
	order($MovieHercs, shutdown, true);
	$MovieFuel1 = getObjectId("MissionGroup\\ImperialMovies\\Fuel\\Fuel");
	$MovieFuel2 = getObjectId("MissionGroup\\ImperialMovies\\Fuel\\Fuel2");
	$Movie = getObjectId("MissionGroup\\ImperialMovies\\ApocMovie");
		
	newFormation( Line, 0,0,0, 0,-40,0, 0,-100,0, 0,-140,0, 0,-200,0, 0,-240,0, 0,-280,0 );
	$Drones = "MissionGroup/ImperialOutpost/Drones";
	$DroneLeader = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Leader");
	$DronePath = "MissionGroup/ImperialOutpost/DronePath";
	$DroneNav = getObjectId("MissionGroup\\ImperialOutpost\\DronePath\\Waypoint");
	$DroneGuard1 = getObjectId("MissionGroup\\ImperialOutpost\\Guards\\Guard1");	
	$DroneGuard2 = getObjectId("MissionGroup\\ImperialOutpost\\Guards\\Guard2");	
	$DroneGuard3 = getObjectId("MissionGroup\\ImperialOutpost\\Guards\\Guard3");	
	$DroneGuard4 = getObjectId("MissionGroup\\ImperialOutpost\\Guards\\Guard4");
	$Drone1 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Leader");
	$Drone2 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Drone2");
	$Drone3 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Drone3");
	$Drone4 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Drone4");
	$Drone5 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Drone5");
	$Drone6 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Drone6");
	$Drone7 = getObjectId("MissionGroup\\ImperialOutpost\\Drones\\Drone7");
	$DronesAtBravo = false;

	$BasePatrol = "MissionGroup/ImpPatrol";
	$BasePatrolPath = "MissionGroup/ImpPatrol/PatrolPath";
	order($BasePatrol, guard, $BasePatrolPath);
	order($BasePatrol, speed, high);
	
	$JailPatrol = "MissionGroup/ImperialJail/JailPatrol";
	$JailPatrolPath = "MissionGroup/ImperialJail/JailPatrolPath";
	
	$TalkedToBreeze = false;
	order($JailPatrol, guard, $JailPatrolPath);
	order($JailPatrol, speed, low);
	$JailPower = getObjectId("MissionGroup\\ImperialCargoBase\\JailPower");
	$JailDoor1 = getObjectId("MissionGroup\\ImperialJail\\JailDoor1");
	$JailDoor2 = getObjectId("MissionGroup\\ImperialJail\\JailDoor2");
	$Jail = getObjectId("MissionGroup\\ImperialJail\\Jail");

	$Breeze1 = getObjectId("MissionGroup\\BreezeAndDes\\BreezeApoc");
	$Breeze2 = getObjectId("MissionGroup\\BreezeAndDes\\BreezeGoad");
	$Breeze3 = getObjectId("MissionGroup\\BreezeAndDes\\BreezeAven");
	createBreeze();

	$Des1 = getObjectId("MissionGroup\\BreezeAndDes\\DesExec");
	$Des2 = getObjectId("MissionGroup\\BreezeAndDes\\DesRecl");
	$Des3 = getObjectId("MissionGroup\\BreezeAndDes\\DesPred");
	createDes();	

	$objective1 = false;
	$objective2 = false;
	$objective3 = false;
	$actionStarted = false;


	$navAlpha = getObjectId("MissionGroup\\Navs\\Alpha");
	$navBravo = getObjectId("MissionGroup\\Navs\\Bravo");
	$navCharlie = getObjectId("MissionGroup\\Navs\\Charlie");

	NavAlphaOn();
	NavCharlieOff();
	NavBravoOff();
	MPcheckBoundary( leave, getObjectID($navCharlie) , 400, onLeaveNavCharlieWarning, 1 );
	marsSounds();	
}


function player::onAdd(%this)                                                                                                                        
{
say ( %this, 0, $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details");
}

function vehicle::onAdd(%this)                                                                                                                        
{

// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;

	if(getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);
     redrop(%this);

	if( $actionStarted == true)
	{
	healObject( %this, -500000);
	}
     }

	if( $actionStarted != true)
	{
	messagebox (%player, "Check the game info tab for game details");
	}

 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {
        //schedule ("healObject(" @ %this @ ", -50000);", 4);
        //messagebox(%player,"Sorry, you can't join until the next game.");
       }
   }
}

function onMissionLoad()
{
  cdAudioCycle( "Watching" , "Mechsoul" , "ss3");  

	$textMsg = "Free Breeze and Des at Nav Alpha. "@
	"Complete these Objectives: "@
	"\n1) Free Breeze and Destroyer-Of-Hope.    "@
      "\n2) Follow any instructions they give you."@
      "\n3) Destroy any cargo the Imperials possess.       "@
      "\nReturn here, Nav Charlie, to win.\n"@
"Respawning is not allowed. Destroying an enemy heals your vehicle and "@
"reloads your weapons. Team Damage is on.";

   %history = 
"\n\nDate: 2834. Two very important members of the rebellion have been captured."@
"It is beleived that they are still alive in an Imperial Jail at Nav Alpha."@
"You must free them, then if you can, destroy their weapons and supplies in their "@
"heavily guarded cargo Base. Be careful of reinforcements... We can afford no casualities."@
""@
"\n\nTo the spirit of Phoenix...";

   setGameInfo ($textMsg @ %history);

}

function structure::onDestroyed(%destroyed, %destroyer)
{
	if( (isGroupDestroyed( $Cargo)) && ( $CargoDestroyed != true) )
	{
	say(0, 0, "<F5>Cargo Destroyed.", "GEN_OC1.wav" );
	$objective2 = true;
	$CargoDestroyed = true;
	order( $CargoProtect, shutdown, false);
	order( $CargoProtect, attack, %destroyer);
	say( 0, 0, "GUARD: Damn Rebels...  can never get any sleep around here...");
	schedule( "say( 0, 0, \"GUARD: I'm going to watch you BURN dust scum.\", \"M11_gonnawacth.wav\");", 3);
	}

	else if( (%destroyed == $JailPower) && ( $PowerDown != true))
	{
	say(0, 0, "<F5>Jail Generator Destroyed.");
	deleteObject( $JailDoor1);
	deleteObject( $JailDoor2);
	schedule( "PowerDown();", 3);
	$PowerDowner = %destroyer;
	schedule( "NavAlphaOff();", 15);
	schedule( "NavBravoOff();", 10);
	NavCharlieOn();
	$PowerDown = true;
	}
		
	else if( (%destroyed == $MovieFuel1) && ( $FuelBlown != true))
	{
		schedule( "order( $MovieHercs, shutdown, false);", RandomInt(1, 4));
		schedule( "order( $MovieHercs, attack, %destroyer);", 8);
		schedule( " Fuel1Blown();", 2);
		$FuelBlown = true;
		damageObject( $MovieFuel2, 50000);
	}

	else if( (%destroyed == $MovieFuel2) && ( $FuelBlown != true))
	{
		schedule( "order( $MovieHercs, shutdown, false);", RandomInt(1, 4));
		schedule( "order( $MovieHercs, attack, %destroyer);", 6);
		schedule( " Fuel2Blown();", 2);
		$FuelBlown = true;
		damageObject( $MovieFuel1, 50000);
	}
}

function structure::onAttacked(%attacked, %attacker)
{
	if( %attacked == $MovieFuel1)
	{
		schedule( "order( $MovieHercs, shutdown, false);", RandomInt(1, 4));
	}

	else if( %attacked == $MovieFuel2)
	{
		schedule( "order( $MovieHercs, shutdown, false);", RandomInt(1, 4));
	}	
}

function vehicle::onAttacked( %this, %who)
{
	if( %this == $CargoProtect)
	{
		order( $CargoProtect, shutdown, false);
	}

	else if( %this == $MovieHercs)
	{
		order( $MovieHercs, shutdown, false);
	}
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
	// give the death messages...
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }

	if( %destroyed == $clone1)
	{
		%again1 = RandomInt(1,3);
		if( %again1 == 1)
		{
			%clone1 = cloneVehicle( $clone1);
			setTeam( %clone1, *IDSTR_TEAM_RED);
			redrop( %clone1);
			setPosition( %clone1, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));	
		}
	}
   	 
	else if( %destroyed == $clone2)
	{
		%again2 = RandomInt(1,3);
		if( %again2 == 1)
		{
			%clone2 = cloneVehicle( $clone2);
			setTeam( %clone2, *IDSTR_TEAM_RED);
			redrop( %clone2);	
			setPosition( %clone2, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));
		}
	}

	else if( %destroyed == $clone3)
	{
		%again3 = RandomInt(1,3);
		if( %again3 == 1)
		{
			%clone3 = cloneVehicle( $clone3);
			setTeam( %clone3, *IDSTR_TEAM_RED);
			redrop( %clone3);
			setPosition( %clone3, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));
			}
	}

	else if( %destroyed == $clone4)
	{
		%again4 = RandomInt(1,3);
		if( %again4 == 1)
		{
			%clone4 = cloneVehicle( $clone4);
			setTeam( %clone4, *IDSTR_TEAM_RED);
			redrop( %clone4);
			setPosition( %clone4, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));
		}
	}

	else if( %destroyed == $clone5)
	{
		%again5 = RandomInt(1,3);
		if( %again5 == 1)
		{
			%clone5 = cloneVehicle( $clone5);
			setTeam( %clone5, *IDSTR_TEAM_RED);
			redrop( %clone5);
			setPosition( %clone5, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));
		}
	}

	else if( %destroyed == $clone6)
	{
		%again6 = RandomInt(1,3);
		if( %again6 == 1)
		{
			%clone6 = cloneVehicle( $clone6);
			setTeam( %clone6, *IDSTR_TEAM_RED);
			redrop( %clone6);	
			setPosition( %clone6, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));
		}
	}

	else if( %destroyed == $clone7)
	{
		%again7 = RandomInt(1,3);
		if( %again7 == 1)
		{
			%clone7 = cloneVehicle( $clone7);
			setTeam( %clone7, *IDSTR_TEAM_RED);
			redrop( %clone7);
			setPosition( %clone7, RandomInt( -490, 90), RandomInt(1660, 2620), RandomInt( 80, 90));
		}
	}
  
  if ( $actionStarted == true ) 
	{
	checkForPlayersDead();
	}

	if( (isGroupDestroyed ( $JailPatrol ) ) && ( $JailStuffDone != true ))
	{
	say( 0, 0, "<F5>{FiRe}<F4>Breeze<F5>{A*<F4>: Help, me and Des can't get out of this damn jail...");
	schedule( "say( 0, 0, \" <F5>{FiRe}<F4>Breeze<F5>{A*<F4>: I saw some kind of power generator back at the cargo base... \");", 2);
	schedule( "say( 0, 0, \" {FiRe}DestroyerOf-Hope: Yeah, I think Breeze is right.\");", 3); 
	schedule( "say( 0, 0, \" <F5>{FiRe}<F4>Breeze<F5>{A*<F4>: Destroy it, and anything they have in that bunker.\");", 5);
 	schedule( "say( 0, 0, \" <F5>{FiRe}<F4>Breeze<F5>{A*<F4>: I also heard the guards talking about some kind of secret convoy. If you see it, destroy that too...\");", 7);
	schedule( "say( 0, 0, \" {FiRe}DestroyerOf-Hope: After we get outta here, we are gonna <F6> KICK SOME IMPERIAL ASS!!!\");", 10);
	schedule( "say( 0, 0, \" <F5>{FiRe}<F4>Breeze<F5>{A*<F4>: <F6>Hurry...\");", 16);
	setTeam( $Breeze, *IDSTR_TEAM_YELLOW);
	setTeam( $Des, *IDSTR_TEAM_YELLOW);
	NavBravoOn();
	NavAlphaOff();
	$TalkedToBreeze = true;

	schedule( "DroneTeleport();", 5);
	$JailStuffDone = true;
	}	
	
	healObject( %destroyer, 5000);
	healObject( %destroyer, 5000);
	healObject( %destroyer, 5000);

	reloadObject( %destroyer, 5000);
	reloadObject( %destroyer, 5000);

	if( (isGroupDestroyed( $Drones)) && ($DronesAtBravo != true))
	{
		say( 0, 0, "<F5>Drones destroyed before resupply.", "GEN_OC1.wav");
		$objective3 = true;
	}

}

function checkForPlayersDead()
{
  %allDead = true;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {

         %allDead = false;
       }
     }

  if ( %allDead == true ) schedule("missionFailed();", 3);
}

function missionFailed()
{
  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );
  // $MissionCycling::Stage0 = "c_invasion";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}

function winCondition()
{
  flushConsoleScheduler();
  %howmany = 0;

  %text = "\nBreeze and Des Rescued: ";
  if ( $objective1 == true )
    {
     %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }

  %text = %text @ "\nCargo Destroyed: ";
  if ( $objective2 == true )
    {
      %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }

  %text = %text @ "\nDrones Destroyed: ";
  if ( $objective3 == true )
    {
      %howmany++;
     %text = %text @ "Successful";
    }
   else
    {
     %text = %text @ "Failed";
    }


  if ( %howmany == 3  ) %text = %text @ " Excellent work team.";

  messageBox(0, "Mission Completed, " @ %howmany @ " of 3 objectives completed. "@ %text );
  // $MissionCycling::Stage0 = "c_invasion";
  // $server::Mission = $MissionCycling::Stage0;
  missionEndConditionMet();
  // schedule("missionEndConditionMet();", 10);
}


function vehicle::onArrived(%vehicleId, %where)
{
	if((%vehicleId == $DroneLeader) && (%where == $DroneNav))
	{
	 say(0, 0, "<F5>The Imperial Cargo Base has been resupplied with the experimental tech... Who knows what kind of technology they possess now.");
	 order( $Drones, shutdown, true);
	 createNewImpTech();
	 $DronesAtBravo = true;
	}
}

function createNewImpTech()
{
	$NewTech = "MissionGroup/NewTechStuff";
	%Bus = getObjectId("MissionGroup\\NewTechStuff\\Bus"); 
	%Bike = getObjectId("MissionGroup\\NewTechStuff\\Bike");
	%PlExec = getObjectId("MissionGroup\\NewTechStuff\\PlExec");
	%PlJudg = getObjectId("MissionGroup\\NewTechStuff\\PlJudg");
	%HaApoc = getObjectId("MissionGroup\\NewTechStuff\\HaApoc");//100.
	%PirApoc = getObjectId("MissionGroup\\NewTechStuff\\PirApoc");
	%HaPred = getObjectId("MissionGroup\\NewTechStuff\\HaPred");
	
	$clone1 = cloneVehicle( %Bus);
	$clone2 = cloneVehicle( %Bike);
	$clone3 = cloneVehicle( %PlExec);
	$clone4 = cloneVehicle( %PlJudg);
	$clone5 = cloneVehicle( %HaApoc);
	$clone6 = cloneVehicle( %PirApoc);
	$clone7 = cloneVehicle( %HaPred);

	%x1 = randomInt(-560, 93);
	%y1 = randomInt(1580, 2730);
	%z1 = getTerrainHeight( %x1, %y1);
	setPosition($clone1, %x1, %y1, %z1+40);
		
	%x2 = randomInt(-560, 93);
	%y2 = randomInt(1580, 2730);
	%z2 = getTerrainHeight( %x2, %y2);
	setPosition($clone2, %x2, %y2, %z2+40);
	
	%x3 = randomInt(-560, 93);
	%y3 = randomInt(1580, 2730);
	%z3 = getTerrainHeight( %x3, %y3);
	setPosition($clone3, %x3, %y3, %z3+40);
	
	%x4 = randomInt(-560, 93);
	%y4 = randomInt(1580, 2730);
	%z4 = getTerrainHeight( %x4, %y4);
	setPosition($clone4, %x4, %y4, %z4+40);
	
	%x5 = randomInt(-560, 93);
	%y5 = randomInt(1580, 2730);
	%z5 = getTerrainHeight( %x5, %y5);
	setPosition($clone5, %x5, %y5, %z5+40);
	
	%x6 = randomInt(-560, 93);
	%y6 = randomInt(1580, 2730);
	%z6 = getTerrainHeight( %x6, %y6);
	setPosition($clone6, %x6, %y6, %z6+40);
	
	%x7 = randomInt(-560, 93);
	%y7 = randomInt(1580, 2730);
	%z7 = getTerrainHeight( %x7, %y7);
	setPosition($clone7, %x7, %y7, %z7+40);
	
}

function CreateBreeze()
{
	%x = 2035;
	%y = 3900;
	%z = 93;

	%Breeze = RandomInt(1,3);
	if( %Breeze == 1)
	{
		setPosition( $Breeze1, %x, %y, %z);
		$Breeze = $Breeze1;
	}
	else if(%Breeze == 2)
	{
		setPosition( $Breeze2, %x, %y, %z);
		$Breeze = $Breeze2;
	}
	else if(%Breeze == 3)
	{
		setPosition( $Breeze3, %x, %y, %z);
		$Breeze = $Breeze3;
	}

	setTeam( $Breeze, *IDSTR_TEAM_NEUTRAL);

	order( $Breeze, shutdown, true);

	setPilotId( $Breeze, 28);
}

function CreateDes()
{
	%x = 2035;
	%y = 3930;
	%z = 93;

	%Des = RandomInt(1,3);
	if( %Des == 1)
	{
		setPosition( $Des1, %x, %y, %z);
		$Des = $Des1;
	}
	else if(%Des == 2)
	{
		setPosition( $Des2, %x, %y, %z);
		$Des = $Des2;
	}
	else if(%Des == 3)
	{
		setPosition( $Des, %x, %y, %z);
		$Des = $Des3;
	}

	setTeam( $Des, *IDSTR_TEAM_NEUTRAL);

	order( $Des, shutdown, true);

	setPilotId( $Des, 29);
}

function PowerDown()
{
	if( $TalkedToBreeze == true)
	{
	 say(0, 0, "<F5>{FiRe}<F4>Breeze<F5>{A*<F4>: Thanks guys... We are joining on you now.");
	 schedule( "say( 0, 0, \"{FiRe}DestroyerOf-Hope: <F6>Hurt, Maim, Kill.\", \"C3_hurtmaimkill.WAV\");", 2);
	 schedule( "say( 0, 0, \"{FiRe}DestroyerOf-Hope: Heh heh heh...\");", 2);
	}

	$objective1 = true;
	deleteObject( $Jail);
	order( $Des, shutdown, false);
	order( $Breeze, shutdown, false);
	order( $Des, guard, $PowerDowner);
	order( $Breeze, guard, $Des);
	order( $Des, speed, high);
	setTeam( $Breeze, *IDSTR_TEAM_YELLOW);
	setTeam( $Des, *IDSTR_TEAM_YELLOW);
}

function vehicle::onScan(%scanned, %scanner)
{
	if( %scanned == $Breeze)
	{
		order( $Breeze, guard, %scanner);
	}
	else if( %scanned == $Des)
	{
		order( $Des, guard, %scanner);
	}
}

function onLeaveNavCharlieWarning()
{
   $actionStarted = true;
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");
   schedule( "MPcheckBoundary( enter, getObjectID($navCharlie) , 300, onArriveNavCharlie, 10 );", 5);	
}

function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
           %func = %callback @ "(" @ %obj1 @ ");";
           schedule( %func, 0 );
           %jobRun = true;
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          %func = %callback @ "();";
          schedule( %func, 0 );
          %jobRun = true;
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );
   }

}

function onArriveNavCharlie()
{

 %obj1 = getObjectID ( $navCharlie );
 %howMany = countLivePlayers ();

 %howManyAreClose = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
          %var = getDistance( %obj1, %playerVeh );
          if ( %var < 300 ) %howManyAreClose++;
       }
     }

  if ( %howManyAreClose == %howMany ) 
    {
     winCondition();
    }
   else
    {
      schedule ("onArriveNavCharlie();", 10 );
    }

}

function NavAlphaOn()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navAlpha, true, %playerVeh  );
     }
}

function NavBravoOn()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
}

function NavCharlieOn()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navCharlie, true, %playerVeh  );
     }
}

function NavAlphaOff()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navAlpha, false, %playerVeh  );
     }
}

function NavBravoOff()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, false, %playerVeh  );
     }
}

function NavCharlieOff()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navCharlie, false, %playerVeh  );
     }
}


Pilot Breeze
{
id = 28;
name = "{FiRe} Breeze {A*";
skill = 1.6;
accuracy = 1.3;
aggressiveness =  1.4;
activateDist = 1300.0;
deactivateBuff = 100.0;
targetFreq = 1.0;
trackFreq = 0.0;
fireFreq = 0.5;
LOSFreq = 0.2;
orderFreq = 1.7;
};

Pilot Des
{
id = 29;
name = "{FiRe}DestroyerOf-Hope";
skill = 1.4;
accuracy = 1.8;
aggressiveness =  1.9;
activateDist = 1300.0;
deactivateBuff = 100.0;
targetFreq = 0.3;
trackFreq = 0.0;
fireFreq = 0.3;
LOSFreq = 0.4;
orderFreq = 1.6;
};

function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}

function DroneTeleport()
{
	%x1 = 719;
	%y1 = -824;
	%z1 = 60;
	
	%x2 = 719;
	%y2 = -864;
	%z2 = 64;
	
	%x3 = 719;
	%y3 = -904;
	%z3 = 70;

	%x4 = 719;
	%y4 = -964;
	%z4 = 74;

	%x5 = 719;
	%y5 = -1004;
	%z5 = 80;

	%x6 = 719;
	%y6 = -1064;
	%z6 = 84;

	%x7 = 719;
	%y7 = -1104;
	%z7 = 90;

	setPosition( $Drone1, %x1, %y1, %z1);
	setPosition( $Drone2, %x2, %y2, %z2);
	setPosition( $Drone3, %x3, %y3, %z3);
	setPosition( $Drone4, %x4, %y4, %z4);
	setPosition( $Drone5, %x5, %y5, %z5);
	setPosition( $Drone6, %x6, %y6, %z6);
	setPosition( $Drone7, %x7, %y7, %z7);
	order( $Drones, guard, $DronePath);
	order( $DroneLeader, makeLeader, true);
	order( $Drones, speed, medium);
	order( $DroneGuard1, guard, $DroneLeader);
	order( $DroneGuard2, guard, $DroneGuard1);
	order( $DroneGuard3, guard, $DroneGuard2);
	order( $DroneGuard4, guard, $DroneGuard3);
}

function Fuel1Blown()
{
	damageArea( $Movie, 0, 0, 0, 300, 1200);
}

function Fuel2Blown()
{

	damageArea( $Movie, 0, 0, 0, 700, 1000);
}